package net.sf.sql2java.conversion;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author dge2
 */
public class Convertor {
    private Map<String, KeywordGroup> groups = new HashMap<String, KeywordGroup>();

// -- Translation -------------------------------------------------------------
    
    public String translateTo(String target, String input) {
    	KeywordGroup group = getKeywordGroup(target);
    	
    	if (group == null) return input;
    	else return group.translate(input);
    }
    
// -- KeywordGroup Map Manipulation -------------------------------------------
    
    public void addKeywordGroup(KeywordGroup group) {
        if (groups == null)
            groups = new HashMap<String, KeywordGroup>();
        
        groups.put(group.getName(), group);
    }
    
    public void removeKeywordGroup(KeywordGroup group) {
        if (groups != null)
            groups.remove(group.getName());
    }
    
    public KeywordGroup getKeywordGroup(String groupName) {
        if (groups != null)
            return groups.get(groupName);
        
        return null;
    }

// -- Getters -----------------------------------------------------------------
    
    public Map<String, KeywordGroup> getKeywordGroups() {
    	return groups;
    }
    
// -- Setters -----------------------------------------------------------------
    
    public void setKeywordGroups(Map<String, KeywordGroup> groups) {
    	this.groups = groups;
    }
}
