package net.sf.sql2java.generator.merger;

import java.util.Properties;
import java.util.Set;

import net.sf.sql2java.generator.writer.merge.Conflict;

import org.apache.log4j.Logger;

public abstract class AbstractMerger {
	private static Logger LOGGER = Logger.getLogger(AbstractMerger.class);
	private Properties properties;

// -- Merging -----------------------------------------------------------------
	
	public void merge(Set<Conflict> conflicts) {
		for (Conflict conflict : conflicts) {
			try {
				merge(conflict);
			} catch (Exception e) {
				// -- log the exception
				LOGGER.error("Unable to merge conflict!", e);
			}
		}
		
		try {
			cleanup(conflicts);
		} catch (Exception e) {
			
		}
	}
	
	public abstract void merge(Conflict conflict) throws Exception;
	
	public abstract void cleanup(Set<Conflict> conflicts) throws Exception;
	
// -- Proprerty Handlers ------------------------------------------------------
	
	public void setProperty(String name, String value) {
		properties.setProperty(name, value);
	}
	
	public String getProperty(String name) {
		return properties.getProperty(name);
	}
	
	public String getProperty(String name, String defaultValue) {
		return properties.getProperty(name, defaultValue);
	}
	
	public Properties getProperties() {
		return properties;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setProperties(Properties properties) {
		this.properties = properties;
	}
}
